View Issue Details

IDProjectCategoryView StatusLast Update
0012041LazarusLCLpublic2008-09-22 23:23
ReporterDominique Louis Assigned ToPaul Ishenin  
PrioritynormalSeveritycrashReproducibilityalways
Status closedResolutionfixed 
Product Version0.9.25 (SVN) 
Target Version0.9.26Fixed in Version0.9.25 (SVN) 
Summary0012041: Mac OS X : ImageList.ReplaceMasked crashes...
DescriptionWhen calling
ImageList.ReplaceMasked ( index, mybitmap, mybitmap.Canvas.Pixels[ 0, mybitmap.Height - 1 ] );

I get an AV.

Crash report below...
Thread 0 Crashed:
0 <<00000000>> 0x00000000 0 + 0
1 Game_Maker 0x001056b1 IMGLIST_TCUSTOMIMAGELIST_$__INTERNALREPLACE$LONGINT$HBITMAP$HBITMAP + 209
2 Game_Maker 0x00106a3c IMGLIST_TCUSTOMIMAGELIST_$__REPLACEMASKED$LONGINT$TCUSTOMBITMAP$TGRAPHICSCOLOR + 204
3 Game_Maker 0x0006f2ae RESOURCE_ICON_RESOURCE_ICON_REPLACE$LONGINT$TBITMAP + 94
4 Game_Maker 0x0008f008 SPRITE_MAIN_SPRITE_ICON_CHANGED$LONGINT + 88
5 Game_Maker 0x00016447 FORMS_TCUSTOMFORM_$__DOCLOSE$TCLOSEACTION + 71
6 Game_Maker 0x00018668 FORMS_TCUSTOMFORM_$__CLOSE + 216
7 Game_Maker 0x0008e059 SPRITE_FORM_TSPRITEFORM_$__OKBTNCLICK$TOBJECT + 25
8 Game_Maker 0x0013b8c9 STDCTRLS_TBUTTONCONTROL_$__CLICK + 41
9 Game_Maker 0x0013bf2f STDCTRLS_TCUSTOMBUTTON_$__CLICK + 79
10 Game_Maker 0x00146509 BUTTONS_TCUSTOMBITBTN_$__CLICK + 73
11 Game_Maker 0x0013c124 STDCTRLS_TCUSTOMBUTTON_$__WMDEFAULTCLICKED$TLMESSAGE + 36
12 Game_Maker 0x0000ac99 SYSTEM_TOBJECT_$__DISPATCH$formal + 153
13 Game_Maker 0x0011e930 CONTROLS_TWINCONTROL_$__WNDPROC$TLMESSAGE + 656
14 Game_Maker 0x001a731b LCLMESSAGEGLUE_DELIVERMESSAGE$TOBJECT$formal$$LONGINT + 123
15 Game_Maker 0x001a73e6 LCLMESSAGEGLUE_SENDSIMPLEMESSAGE$TCONTROL$LONGWORD$$LONGINT + 54
16 Game_Maker 0x001a7640 LCLMESSAGEGLUE_LCLSENDCLICKEDMSG$TCONTROL$$LONGINT + 32
17 Game_Maker 0x001c8762 CARBONBUTTONS_TCARBONCUSTOMBUTTON_$__HIT$SMALLINT + 34
18 Game_Maker 0x001bd0c0 CARBONPRIVATE_CARBONCONTROL_HIT$EVENTHANDLERCALLREF$EVENTREF$TCARBONWIDGET$$LONGINT + 240
19 com.apple.HIToolbox 0x92df04d7 DispatchEventToHandlers(EventTargetRec*, OpaqueEventRef*, HandlerCallRec*) + 1093
20 com.apple.HIToolbox 0x92defb7c SendEventToEventTargetInternal(OpaqueEventRef*, OpaqueEventTargetRef*, HandlerCallRec*) + 304
21 com.apple.HIToolbox 0x92df6f7c SendEventToEventTarget + 56
22 com.apple.HIToolbox 0x92eaa6a5 SendControlHit(HIView*, short, unsigned long) + 187
23 com.apple.HIToolbox 0x92eaa596 HIView::NotifyControlHit(short, unsigned long) + 34
24 com.apple.HIToolbox 0x92eb3e38 HIView::ClickInternal(CGPoint const&, unsigned long, void (*)(OpaqueControlRef*, short), OpaqueEventRef*, bool) + 270
25 com.apple.HIToolbox 0x92e8f025 HIView::ClickSelf(OpaqueEventRef*) + 371
26 com.apple.HIToolbox 0x92e14612 HIView::EventHandler(OpaqueEventHandlerCallRef*, OpaqueEventRef*, void*) + 2386
27 com.apple.HIToolbox 0x92df04d7 DispatchEventToHandlers(EventTargetRec*, OpaqueEventRef*, HandlerCallRec*) + 1093
28 com.apple.HIToolbox 0x92defb7c SendEventToEventTargetInternal(OpaqueEventRef*, OpaqueEventTargetRef*, HandlerCallRec*) + 304
29 com.apple.HIToolbox 0x92df6f7c SendEventToEventTarget + 56
30 com.apple.HIToolbox 0x92e8ed4f HIView::Click(OpaqueEventRef*) + 329
31 com.apple.HIToolbox 0x92e8eb8b HandleClickAsHIView + 145
32 com.apple.HIToolbox 0x92e8e531 HandleWindowClick + 507
33 com.apple.HIToolbox 0x92e8dffe HandleMouseEvent + 895
34 com.apple.HIToolbox 0x92e36468 StandardWindowEventHandler + 86
35 com.apple.HIToolbox 0x92df04d7 DispatchEventToHandlers(EventTargetRec*, OpaqueEventRef*, HandlerCallRec*) + 1093
36 com.apple.HIToolbox 0x92defb7c SendEventToEventTargetInternal(OpaqueEventRef*, OpaqueEventTargetRef*, HandlerCallRec*) + 304
37 com.apple.HIToolbox 0x92df6f7c SendEventToEventTarget + 56
38 com.apple.HIToolbox 0x92df740f ToolboxEventDispatcherHandler(OpaqueEventHandlerCallRef*, OpaqueEventRef*, void*) + 1169
39 com.apple.HIToolbox 0x92df088e DispatchEventToHandlers(EventTargetRec*, OpaqueEventRef*, HandlerCallRec*) + 2044
40 com.apple.HIToolbox 0x92defb7c SendEventToEventTargetInternal(OpaqueEventRef*, OpaqueEventTargetRef*, HandlerCallRec*) + 304
41 com.apple.HIToolbox 0x92df6f7c SendEventToEventTarget + 56
42 Game_Maker 0x00199651 CARBONINT_TCARBONWIDGETSET_$__APPPROCESSMESSAGES + 401
43 Game_Maker 0x0001d8f0 FORMS_TAPPLICATION_$__HANDLEMESSAGE + 48
44 Game_Maker 0x0001dc31 FORMS_TAPPLICATION_$__RUNLOOP + 81
45 Game_Maker 0x00198849 CARBONINT_EVENTLOOPEVENTHANDLER$EVENTHANDLERCALLREF$EVENTREF$POINTER$$LONGINT + 393
46 com.apple.HIToolbox 0x92df04d7 DispatchEventToHandlers(EventTargetRec*, OpaqueEventRef*, HandlerCallRec*) + 1093
47 com.apple.HIToolbox 0x92defb7c SendEventToEventTargetInternal(OpaqueEventRef*, OpaqueEventTargetRef*, HandlerCallRec*) + 304
48 com.apple.HIToolbox 0x92defa41 SendEventToEventTargetWithOptions + 55
49 com.apple.HIToolbox 0x92df70e3 ToolboxEventDispatcherHandler(OpaqueEventHandlerCallRef*, OpaqueEventRef*, void*) + 357
50 com.apple.HIToolbox 0x92df088e DispatchEventToHandlers(EventTargetRec*, OpaqueEventRef*, HandlerCallRec*) + 2044
51 com.apple.HIToolbox 0x92defb7c SendEventToEventTargetInternal(OpaqueEventRef*, OpaqueEventTargetRef*, HandlerCallRec*) + 304
52 com.apple.HIToolbox 0x92df6f7c SendEventToEventTarget + 56
53 com.apple.HIToolbox 0x92e3aeb3 ToolboxEventDispatcher + 81
54 com.apple.HIToolbox 0x92e398cb RunApplicationEventLoop + 165
55 Game_Maker 0x00199417 CARBONINT_TCARBONWIDGETSET_$__APPRUN$TAPPLICATIONMAINLOOP + 583
56 Game_Maker 0x0001dbd2 FORMS_TAPPLICATION_$__RUN + 114
57 Game_Maker 0x00002377 PASCALMAIN + 519
58 Game_Maker 0x00002152 start + 258
59 Game_Maker 0x00002079 start + 41
TagsNo tags attached.
Fixed in Revision16435, 16496
LazTarget0.9.26
WidgetsetCarbon
Attached Files

Activities

Paul Ishenin

2008-09-05 12:19

manager   ~0022008

Do you have a test project?

Paul Ishenin

2008-09-05 13:25

manager   ~0022012

There was few errors which I fixed. Please retest and close if ok.

Dominique Louis

2008-09-08 23:25

reporter   ~0022074

I just grabbed the latest SVN ( 16491 ) and it crashes in exactly the same place.

I also noticed that ImageList.AddMasked also crashes.

Paul Ishenin

2008-09-09 05:50

manager   ~0022077

It was a bug in fpc. Hope will work now.

2008-09-09 06:11

 

ReplaceMasked.zip (5,149 bytes)

Dominique Louis

2008-09-14 18:32

reporter   ~0022225

Thanks for the fixing it, it works fine now.

Dominique Louis

2008-09-22 19:11

reporter   ~0022364

I've created a new report for this AddMask bug
http://bugs.freepascal.org/view.php?id=12210
Please close this one as they are really unrelated. Appologies for the waste of bandwidth.

Issue History

Date Modified Username Field Change
2008-09-02 19:47 Dominique Louis New Issue
2008-09-02 19:47 Dominique Louis Widgetset => Carbon
2008-09-05 08:11 Paul Ishenin LazTarget => 0.9.26
2008-09-05 08:11 Paul Ishenin Status new => acknowledged
2008-09-05 08:11 Paul Ishenin Target Version => 0.9.26
2008-09-05 12:19 Paul Ishenin Note Added: 0022008
2008-09-05 12:19 Paul Ishenin Status acknowledged => feedback
2008-09-05 13:25 Paul Ishenin Fixed in Revision => 16435
2008-09-05 13:25 Paul Ishenin Status feedback => resolved
2008-09-05 13:25 Paul Ishenin Fixed in Version => 0.9.25 (SVN)
2008-09-05 13:25 Paul Ishenin Resolution open => fixed
2008-09-05 13:25 Paul Ishenin Assigned To => Paul Ishenin
2008-09-05 13:25 Paul Ishenin Note Added: 0022012
2008-09-08 23:25 Dominique Louis Status resolved => assigned
2008-09-08 23:25 Dominique Louis Resolution fixed => reopened
2008-09-08 23:25 Dominique Louis Note Added: 0022074
2008-09-09 05:50 Paul Ishenin Fixed in Revision 16435 => 16435, 16496
2008-09-09 05:50 Paul Ishenin Status assigned => resolved
2008-09-09 05:50 Paul Ishenin Resolution reopened => fixed
2008-09-09 05:50 Paul Ishenin Note Added: 0022077
2008-09-09 06:11 Paul Ishenin File Added: ReplaceMasked.zip
2008-09-14 18:32 Dominique Louis Status resolved => closed
2008-09-14 18:32 Dominique Louis Note Added: 0022225
2008-09-21 20:47 Dominique Louis Status closed => assigned
2008-09-21 20:47 Dominique Louis Resolution fixed => reopened
2008-09-22 19:11 Dominique Louis Note Added: 0022364
2008-09-22 19:26 Vincent Snijders Status assigned => resolved
2008-09-22 19:26 Vincent Snijders Resolution reopened => fixed
2008-09-22 23:23 Dominique Louis Status resolved => closed